PiVariety-V4L2 Driver Release version

Currently using the IMX462 camera with Bullseye 32-bit on a RPi4 and all is working well.
I’m running on a PiOS version that has the 5.10.63.V7l+ kernel and the matching Pivariety driver release.

There has been a recent Bullseye PiOS release with a new kernel version of 5.10.92-v7l+
Will there be a matching Arducam driver release at some point so that the PiOS upgrade can be accepted and installed?

Thanks

We have released the 5.10.92 kernel driver a few days ago, can you confirm that the installation script installs it properly?

Hi Wong,

I flashed the most recent 32-bit Bullseye image (2022-01-28) and added the up to date upgrades.

Then followed the installation script for the driver installation.

dmesg, dev/video* and v4l2-ctl all showed the expected results.

Then installed the libcamera app and dev packages and tried a libcamera-hello.
Window appeared but no camera image.
Did a reboot and tried libcamera-hello again and all is good. Camera image appeared as normal.

Will now go ahead and install the python libcamera package.

Great stuff!
Thanks again

I’ve re-installed the Python libcamera package and all is running well with the new
5.10.92-v7l+ driver. I’ve created a short cribsheet as a reminder how to get everything installed and running and will copy it below in case it helps anyone else.

Instruction cribsheet to get Python libcamera , Opencv and numpy installed to allow demos to run.

These are for my situation of 32 bit Bullseye with Python 3.9 pre-installed.

Follow the link in

Click to download the zip folder.

Ignore the Google warning on virus checking and download anyway.

Extract to new folder and read readme.md

Open a terminal and follow instructions

 ## python 3.9

```bash
cd libcamera_python
python3 -m pip install ./libcamera-1.0.1-cp39-cp39m-linux_armv7l.whl
```

but change libcamera-python directory name to match the extracted one, (add_1.0.1 at this time).

Change typo in “python3 -m pip install ./libcamera-1.0.1-cp39-cp39m-linux_armv7l.whl”

to remove m after cp39m to match actual .whl file name, before running command.

To install OpenCV go to

Select the 4.5.4.60 release and presss blue Files button.

Choose the 4 th option

Follow and copy paste the two install lines at the top of the page.

At this point OpenCv is installed but is a version ahead of the default numpy package so …

pip3 install --upgrade numpy

Then all packages should match and demos will run.

Thank you so much for the information, I’m sure it will help others!

Hi,
I’ve just flashed a fresh 32bit Bullseye image (5.10.92-v7l+ #1514) to a card and ran the Arducam PiVariety installation script.

dmesg | grep arducam shows the usual response

ls /dev/video* -l also shows a list of video devices, though I’m not sure they match the same command issued after last week’s install.

But…

v4l2-ctl --list-formats-ext

shows a long list of 45 VIDIOC_ENUM_FMT modes, all at 16376x16376, which don’t match the IMX462 device so it won’t enable?

Any suggestions?

Thanks

And to follow up the above question,
I tried again to install the driver using the alternative single manual steps and it successfully installed, with just the two video capture formats liste.
However after installing the libcamera and apps I got this message in the log after trying to run libcamera-hello
[0:00:27.635050538] [1186] ERROR IPAProxy ipa_proxy.cpp:149 Configuration file ‘arducam-pivariety.json’ not found for IPA module ‘raspberrypi’
[0:00:28.043510075] [1186] WARN RPI raspberrypi.cpp:1233 Mismatch between Unicam and CamHelper for embedded data usage!
[0:00:28.044220760] [1186] ERROR RPI raspberrypi.cpp:1261 Unicam driver does not use the MediaController, please update your kernel!
[0:00:28.044926242] [1186] ERROR RPI raspberrypi.cpp:1144 Failed to register camera arducam-pivariety 10-000c: -22
ERROR: *** no cameras available ***

What is the best way to get matching sets of driver and libcamera/libcamera-apps and ideally also the most up to date versions of libcamera and the apps.?

Thanks again

We recently updated libcamera and kernel driver for 5.10.92, from the log you need to reinstall the driver.

The latest kernel driver is using media-controller, use v4l2-ctl --list-formats-ext to list the formats supported by media,
if you want to check the format of the camera, please use
libcamera-still --list-cameras

Hi Wong,

I’ve reflashed a card and followed the standard installation script for both the kernel driver and the libcamera and apps.

the output from libcamera-still --list cameras is as below:-

libcamera-still --list-cameras
[0:41:31.122697118] [3012]  INFO Camera camera_manager.cpp:293 libcamera v0.0.0
[0:41:31.143491345] [3013]  WARN CameraSensorProperties camera_sensor_properties.cpp:141 No static properties available for 'arducam-pivariety'
[0:41:31.143543086] [3013]  WARN CameraSensorProperties camera_sensor_properties.cpp:143 Please consider updating the camera sensor properties database
[0:41:31.143589178] [3013] ERROR CameraSensor camera_sensor.cpp:551 'arducam-pivariety 10-000c': Camera sensor does not support test pattern modes.
[0:41:31.159222681] [3013] ERROR IPAProxy ipa_proxy.cpp:149 Configuration file 'arducam-pivariety.json' not found for IPA module 'raspberrypi'
[0:41:31.516955852] [3013]  WARN RPI raspberrypi.cpp:1233 Mismatch between Unicam and CamHelper for embedded data usage!
[0:41:31.517502254] [3013] ERROR DelayedControls delayed_controls.cpp:87 Delay request for control id 0x009a090a but control is not exposed by device /dev/v4l-subdev0
[0:41:31.517669178] [3013]  INFO RPI raspberrypi.cpp:1356 Registered camera /base/soc/i2c0mux/[email protected]/[email protected] to Unicam device /dev/media3 and ISP device /dev/media0
Available cameras

0 : arducam-pivariety [1920x1080] (/base/soc/i2c0mux/[email protected]/[email protected])
Modes: ‘SRGGB10_CSI2P’ : 1920x1080

All the libcamera apps, hello/still/jpeg and vid are working. Thanks yet again .

But when I try the python demos they fail with the following typical message:-
[0:38:05.294393513] [2962] WARN IPAManager ipa_manager.cpp:149 No IPA found in ‘/usr/local/lib/arm-linux-gnueabihf/libcamera’
[0:38:05.294602379] [2962] INFO Camera camera_manager.cpp:293 libcamera v0.0.0
[0:38:05.315879585] [2965] WARN CameraSensorProperties camera_sensor_properties.cpp:141 No static properties available for ‘arducam-pivariety’
[0:38:05.315960175] [2965] WARN CameraSensorProperties camera_sensor_properties.cpp:143 Please consider updating the camera sensor properties database
[0:38:05.316111746] [2965] ERROR RPI raspberrypi.cpp:1030 Failed to load a suitable IPA library

Any suggestions?
Thanks again for your patience and assistance!

Sorry, I forgot to mention, libcamera python wrap hasn’t been updated yet.

Check this:

Thanks!
Ran the new 1.0.2 version and it successfully removed 1.0.1 and installed 1.0.2 and everything is working again.

Where can I get the Python wrap?

I’m using:
Linux raspberrypi 5.10.103-v8+ #1530 SMP PREEMPT Tue Mar 8 13:06:35 GMT 2022 aarch64 GNU/Linux

Still not working.

Sorry, we don’t provide 64bit Python wrap yet, you can test it with 32bit version first.